/*
 Copyright (c) 2009 Devin DeLong
 
 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the "Software"), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:
 
 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
 */

#pragma once
#ifndef BZU_BZ_TYPES_HPP
#define BZU_BZ_TYPES_HPP

#ifndef _BZFS_API_H_
#include "bzfsAPI.h"
#endif

namespace bzu {
  
  namespace v1 {
    
    // Some events
    typedef bz_PlayerUpdateEventData_V1           PlayerUpdateEventData;
    typedef bz_PlayerJoinPartEventData_V1         PlayerJoinPartEventData;
    typedef bz_PlayerDieEventData_V1              PlayerDieEventData;
    typedef bz_CTFCaptureEventData_V1             CTFCaptureEventData;  
    typedef bz_AllowCTFCaptureEventData_V1        AllowCTFCaptureEventData;
    typedef bz_PlayerSpawnEventData_V1            PlayerSpawnEventData;
    typedef bz_ChatEventData_V1                   ChatEventData;
    typedef bz_UnknownSlashCommandEventData_V1    UnknownSlashCommandEventData;  
    typedef bz_GetPlayerSpawnPosEventData_V1      GetPlayerSpawnPosEventData;
    typedef bz_AllowPlayerEventData_V1            AllowPlayerEventData;
    typedef bz_TickEventData_V1                   TickEventData;
    typedef bz_GetWorldEventData_V1               GetWorldEventData;
    typedef bz_GetPlayerInfoEventData_V1          GetPlayerInfoEventData;
    typedef bz_GetAutoTeamEventData_V1            GetAutoTeamEventData;
    
    // Missing the word "Event"
    typedef bz_AllowSpawnData_V1                  AllowSpawnEventData;
    
    // Missing the word "Data"
    typedef bz_ListServerUpdateEvent_V1           ListServerUpdateEventData;  
    
    typedef bz_BanEventData_V1                    BanEventData;
    typedef bz_HostBanEventData_V1                HostBanEventData;
    typedef bz_IdBanEventData_V1                  IdBanEventData;
    typedef bz_KickEventData_V1                   KickEventData;  
    typedef bz_KillEventData_V1                   KillEventData;
    typedef bz_PlayerPausedEventData_V1           PlayerPausedEventData;
    typedef bz_MessageFilteredEventData_V1        MessageFilteredEventData;
    typedef bz_GameStartEndEventData_V1           GameStartEndEventData;
    typedef bz_SlashCommandEventData_V1           SlashCommandEventData;
    typedef bz_PlayerAuthEventData_V1             PlayerAuthEventData;
    typedef bz_ServerMsgEventData_V1              ServerMsgEventData;
    typedef bz_ShotFiredEventData_V1              ShotFiredEventData;
    typedef bz_AnointRabbitEventData_V1           AnointRabbitEventData;
    typedef bz_NewRabbitEventData_V1              NewRabbitEventData;
    typedef bz_ReloadEventData_V1                 ReloadEventData;
    typedef bz_NetTransferEventData_V1            NetTransferEventData;
    typedef bz_LoggingEventData_V1                LoggingEventData;
    typedef bz_FlagTransferredEventData_V1        FlagTransferredEventData;
    typedef bz_FlagGrabbedEventData_V1            FlagGrabbedEventData;  
    typedef bz_AllowFlagGrabEventData_V1          AllowFlagGrabEventData;
    typedef bz_FlagDroppedEventData_V1            FlagDroppedEventData;
    typedef bz_ShotEndedEventData_V1              ShotEndedEventData;
    typedef bz_NewNonPlayerConnectionEventData_V1 NewNonPlayerConnectionEventData;
    typedef bz_PlayerCollisionEventData_V1        PlayerCollisionEventData;
    typedef bz_FlagResetEventData_V1              FlagResetEventData;
    typedef bz_AllowKillCommandEventData_V1       AllowKillCommandEventData;
    typedef bz_ReportFiledEventData_V1            ReportFiledEventData;
    
  }
  
  // Player data
  typedef bz_BasePlayerRecord PlayerRecord; 
  
  // World data
  typedef bz_APIBaseWorldObject WorldObject;
  
  // Utility classes.  These never have consistent naming: bz_Api, bz_API.
  typedef bz_ApiString String;
  typedef bz_APIIntList IntList;
  typedef bz_APIFloatList FloatList;
  typedef bz_APIStringList StringList;
  
  // This is more descriptive
  typedef int PlayerID;
}


#endif /* BZU_BZ_TYPES_HPP */

