/*
 Copyright (c) 2009 Devin DeLong
 
 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the "Software"), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:
 
 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
 */

#pragma once
#ifndef SET_COMMAND_H
#define SET_COMMAND_H

// Plugin
#include "Command.h"

// STL
#include <string>
#include <vector>
#include <map>

// bzfs
#ifndef _BZFS_API_H_
#include "bzfsAPI.h"
#endif

class SetCommand : public Command
  {
    typedef std::map<std::string, bz_eTeamType> TeamMap;
    
  public:
    
    // Initializes the map.
    SetCommand();
    
  private:
    
    // Performs the command
    virtual bool doCommand(const std::vector<std::string> & params);  
    // Cloneable
    virtual SetCommand * doClone() const { return new SetCommand(); }
    
  public:
    ~SetCommand() {  }
    
  private:
    TeamMap teamMap;
  };


#endif /* SET_COMMAND_H */
