/*
 Copyright (c) 2009 Devin DeLong
 
 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the "Software"), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:
 
 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
 */

// bzfs
// This is a BIG header.
// Try to avoid including it if we don't have to.
#ifndef _BZFS_API_H_
#include "bzfsAPI.h"
#endif

// Plugin
#include "CommandHandler.h"
#include "EventHandler.h"

// Defines
#define COMMAND "tw"

// Plugin version macro - expands to a function
BZ_GET_PLUGIN_VERSION

static EventHandler eHandler;
static CommandHandler cHandler;

// Called when the plugin is loaded
BZF_PLUGIN_CALL int bz_Load ( const char* /*commandLine*/ )
{
  bz_registerEvent(bz_eFlagGrabbedEvent, &eHandler);  
  bz_registerCustomSlashCommand(COMMAND, &cHandler);
  bz_debugMessage(4,"TeamWeapons plugin loaded");
  return 0;
}

// Called when the plugin is unloaded
BZF_PLUGIN_CALL int bz_Unload ( void )
{
  bz_removeEvent(bz_eFlagGrabbedEvent, &eHandler);
  bz_removeCustomSlashCommand(COMMAND);
  bz_debugMessage(4,"TeamWeapons plugin unloaded");
  return 0;
}

// Local Variables: ***
// mode: C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8
